Require Import connectives.
Require Import leibniz.
Require Import logic.
Parameter nat : Type.
Parameter S : nat -> nat.
Parameter match_nat_type : forall (return_:Type), return_ -> (nat -> return_) -> nat -> return_.
Axiom axiom_match_nat_type_S : forall return_type, forall (case_O:return_type), forall (case_S:(nat -> return_type)), forall (n:nat), connectives.equal (return_type) (match_nat_type (return_type) case_O case_S (S n)) (case_S n).
Definition eq_match_nat_type_S : forall return_type, forall (case_O:return_type), forall (case_S:(nat -> return_type)), forall (n:nat), leibniz.leibniz (return_type) (match_nat_type (return_type) case_O case_S (S n)) (case_S n) := fun (return_type:Type) => fun (case_O:return_type) => fun (case_S:nat -> return_type) => fun (n:nat) => ((((connectives.equal_leibniz) (return_type)) (match_nat_type (return_type) case_O case_S (S n))) (case_S n)) (((((axiom_match_nat_type_S) (return_type)) (case_O)) (case_S)) (n)).
Parameter filter_nat_type : forall (return_:Type), (nat -> return_) -> nat -> return_.
Axiom axiom_filter_nat_type_S : forall return_type, forall (return_:(nat -> return_type)), forall (n:nat), connectives.equal (return_type) (filter_nat_type (return_type) return_ (S n)) (return_ (S n)).
Definition eq_filter_nat_type_S : forall return_type, forall (return_:(nat -> return_type)), forall (n:nat), leibniz.leibniz (return_type) (filter_nat_type (return_type) return_ (S n)) (return_ (S n)) := fun (return_type:Type) => fun (return_:nat -> return_type) => fun (n:nat) => ((((connectives.equal_leibniz) (return_type)) (filter_nat_type (return_type) return_ (S n))) (return_ (S n))) ((((axiom_filter_nat_type_S) (return_type)) (return_)) (n)).
Parameter minus : nat -> nat -> nat.
Parameter minus_body : nat -> nat -> nat.
Axiom axiom_minus : forall (n:nat), connectives.equal (nat -> nat) (minus n) (filter_nat_type (nat -> nat) minus_body n).
Definition eq_minus : forall (n:nat), leibniz.leibniz (nat -> nat) (minus n) (filter_nat_type (nat -> nat) minus_body n) := fun (n:nat) => ((((connectives.equal_leibniz) (nat -> nat)) (minus n)) (filter_nat_type (nat -> nat) minus_body n)) ((axiom_minus) (n)).
Axiom axiom_minus_body_S : forall (n:nat), connectives.equal (nat -> nat) (minus_body (S n)) (fun (m:nat) => match_nat_type (nat) (S n) (fun (q:nat) => minus n q) m).
Definition eq_minus_body_S : forall (n:nat), leibniz.leibniz (nat -> nat) (minus_body (S n)) (fun (m:nat) => match_nat_type (nat) (S n) (fun (q:nat) => minus n q) m) := fun (n:nat) => ((((connectives.equal_leibniz) (nat -> nat)) (minus_body (S n))) (fun (m:nat) => match_nat_type (nat) (S n) (fun (q:nat) => minus n q) m)) ((axiom_minus_body_S) (n)).
Definition minus_S_S : forall (n:nat), forall (m:nat), logic.eq (nat) (minus (S n) (S m)) (minus n m) := fun (n:nat) => fun (m:nat) => ((((((eq_match_nat_type_S) (nat)) (S n)) (fun (q:nat) => minus n q)) (m)) (fun (y:nat) => logic.eq (nat) (minus (S n) (S m)) y)) ((((eq_minus_body_S) (n)) (fun (y:(nat -> nat)) => logic.eq (nat) (minus (S n) (S m)) (y (S m)))) ((((((eq_filter_nat_type_S) (nat -> nat)) (minus_body)) (n)) (fun (y:(nat -> nat)) => logic.eq (nat) (minus (S n) (S m)) (y (S m)))) ((((eq_minus) (S n)) (fun (y:(nat -> nat)) => logic.eq (nat) (minus (S n) (S m)) (y (S m)))) (((logic.refl) (nat)) (minus (S n) (S m)))))).
